'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

if (typeof window !== 'undefined') {
  require('pdfjs-dist/build/pdf.combined'); // eslint-disable-line
  require('pdfjs-dist/web/compatibility'); // eslint-disable-line
}

var Pdf = function (_Component) {
  (0, _inherits3.default)(Pdf, _Component);

  function Pdf(props) {
    (0, _classCallCheck3.default)(this, Pdf);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Pdf.__proto__ || (0, _getPrototypeOf2.default)(Pdf)).call(this, props));

    _this.state = {};
    _this.onDocumentComplete = _this.onDocumentComplete.bind(_this);
    _this.onPageComplete = _this.onPageComplete.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(Pdf, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.loadPDFDocument(this.props);
      this.renderPdf();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      var pdf = this.state.pdf;

      if (newProps.file && newProps.file !== this.props.file || newProps.content && newProps.content !== this.props.content) {
        this.loadPDFDocument(newProps);
      }

      if (pdf && (newProps.page && newProps.page !== this.props.page || newProps.scale && newProps.scale !== this.props.scale) || newProps.rotate && newProps.rotate !== this.props.rotate) {
        this.setState({ page: null });
        pdf.getPage(newProps.page).then(this.onPageComplete);
      }
    }
  }, {
    key: 'onDocumentComplete',
    value: function onDocumentComplete(pdf) {
      this.setState({ pdf: pdf });
      var onDocumentComplete = this.props.onDocumentComplete;

      if (typeof onDocumentComplete === 'function') {
        onDocumentComplete(pdf.numPages);
      }
      pdf.getPage(this.props.page).then(this.onPageComplete);
    }
  }, {
    key: 'onPageComplete',
    value: function onPageComplete(page) {
      this.setState({ page: page });
      this.renderPdf();
      var onPageComplete = this.props.onPageComplete;

      if (typeof onPageComplete === 'function') {
        onPageComplete(page.pageIndex + 1);
      }
    }
  }, {
    key: 'loadByteArray',
    value: function loadByteArray(byteArray) {
      window.PDFJS.getDocument(byteArray).then(this.onDocumentComplete);
    }
  }, {
    key: 'loadPDFDocument',
    value: function loadPDFDocument(props) {
      var _this2 = this;

      if (props.file) {
        if (typeof props.file === 'string') {
          return window.PDFJS.getDocument(props.file).then(this.onDocumentComplete);
        }
        // Is a File object
        var reader = new FileReader();
        reader.onloadend = function () {
          return _this2.loadByteArray(new Uint8Array(reader.result));
        };
        reader.readAsArrayBuffer(props.file);
      } else if (props.content) {
        var bytes = window.atob(props.content);
        var byteLength = bytes.length;
        var byteArray = new Uint8Array(new ArrayBuffer(byteLength));
        for (var index = 0; index < byteLength; index += 1) {
          byteArray[index] = bytes.charCodeAt(index);
        }
        this.loadByteArray(byteArray);
      } else {
        throw new Error('React-PDFjs works with a file(URL) or (base64)content. At least one needs to be provided!');
      }
      return null;
    }
  }, {
    key: 'renderPdf',
    value: function renderPdf() {
      var page = this.state.page;

      if (page) {
        var canvas = this.canvas;

        if (canvas.getDOMNode) {
          // compatible with react 0.13
          canvas = canvas.getDOMNode();
        }
        var canvasContext = canvas.getContext('2d');
        var _props = this.props,
            scale = _props.scale,
            rotate = _props.rotate;

        var viewport = page.getViewport(scale, rotate);
        canvas.height = viewport.height;
        canvas.width = viewport.width;
        page.render({ canvasContext: canvasContext, viewport: viewport });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          loading = _props2.loading,
          style = _props2.style;
      var page = this.state.page;

      return page ? _react2.default.createElement('canvas', { style: style, ref: function ref(canvas) {
          _this3.canvas = canvas;
        } }) : loading || _react2.default.createElement(
        'div',
        null,
        'Loading PDF...'
      );
    }
  }]);
  return Pdf;
}(_react.Component);

Pdf.displayName = 'React-PDFjs';
Pdf.propTypes = {
  content: _propTypes2.default.string,
  file: _propTypes2.default.string,
  loading: _propTypes2.default.any, // eslint-disable-line
  page: _propTypes2.default.number,
  scale: _propTypes2.default.number,
  rotate: _propTypes2.default.number,
  onDocumentComplete: _propTypes2.default.func,
  onPageComplete: _propTypes2.default.func,
  style: _propTypes2.default.object // eslint-disable-line
};
Pdf.defaultProps = { page: 1, scale: 1.0 };

exports.default = Pdf;